{
Coded By: SadeghPM
contact: SadeghPM@Gmail.com
Site: www.4xmen.ir
27/2/2014
}
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TfrmMain = class(TForm)
    imgPaper: TImage;
    lbledtSpeed: TLabeledEdit;
    procedure imgPaperMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  TVector = Record
    X, Y: Double;
  end;

var
  frmMain: TfrmMain;
  Cnt: Integer = 0;
  Over: Integer = 0;
  A_Start, B_Start: TPoint;

implementation

{$R *.dfm}

Function VPoint(X, Y: Double): TVector;
begin
  result.X := X;
  result.Y := Y;
end;

function Vector(A, B: TPoint): TVector;
begin
  result.X := B.X - A.X;
  result.Y := B.Y - A.Y;
end;

Function Vec_Unit(Vec: TVector): TVector;
Var
  VSize: Double;
begin
  VSize := Sqrt(Sqr(Vec.X) + Sqr(Vec.Y));
  result.X := (Vec.X / VSize) * 10;
  result.Y := (Vec.Y / VSize) * 10;
end;

Function VSize(A, B: TPoint): Double; // Calculate Size of Vector
Var
  Vec: TVector;
begin
  Vec := Vector(A, B);
  result := (Sqrt(Sqr(Vec.X) + Sqr(Vec.Y)));
end;

procedure Calc_CD(A, B: TPoint; Var C, D: TPoint);
Var
  W1, W2, V: TVector;
  F: TPoint;
begin

  V := Vector(A, B);
  W1 := VPoint(V.Y, 0 - V.X);

  C := Point(B.X + Round(W1.X), B.Y + Round(W1.Y));
  D := Point(A.X + Round(W1.X), A.Y + Round(W1.Y));

end;

Procedure ClearScreen;
Var
  R: Trect;
begin
  with frmMain.imgPaper.Canvas do
  begin
    Brush.Style := BsSolid;
    Brush.Color := clWhite;
    FillRect(frmMain.imgPaper.Canvas.ClipRect);
  end;

end;

procedure Draw(A, B, C, D: TPoint);
begin

  with frmMain.imgPaper.Canvas do
  Begin
    // Brush.Style := BsClear;
    Brush.Style := BsSolid;
    Brush.Color := ClBlack + (Over * 3);
    Polygon([A, B, C, D]);
    sleep(strtoint(frmmain.lbledtSpeed.Text));
    application.ProcessMessages;
  End;

end;

procedure NewPoint(A, B, C: TPoint; Var New_A, New_B: TPoint);
Var
  V, U: TVector;
begin
  V := Vector(A, B);
  U := Vec_Unit(V);

  New_A := Point(A.X + Round(U.X), A.Y + Round(U.Y));
  V := Vector(B, C);
  U := Vec_Unit(V);
  New_B := Point(B.X + Round(U.X), B.Y + Round(U.Y));

end;

procedure Draw_Sq(A, B: TPoint);
Var
  New_A, New_B: TPoint;
  C, D: TPoint;
begin

  if VSize(A, B) < 20 then
    exit;
  Calc_CD(A, B, C, D);
  Draw(A, B, C, D);

  NewPoint(A, B, C, New_A, New_B);
  Inc(Over);
  Draw_Sq(New_A, New_B);

end;

procedure TfrmMain.imgPaperMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  case Cnt of
    0:
      A_Start := Point(X, Y);
    1:
      begin
        Over := 0;
        B_Start := Point(X, Y);
        ClearScreen;
        Draw_Sq(A_Start, B_Start);
      end;
  end;

  Cnt := (Cnt + 1) mod 2;
end;

end.
